/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SnapchatControllerActionCampaignRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SnapchatControllerActionCampaignRequest{}

// SnapchatControllerActionCampaignRequest struct for SnapchatControllerActionCampaignRequest
type SnapchatControllerActionCampaignRequest struct {
	OAuthId   *string `json:"oAuthId,omitempty"`
	AccountId *string `json:"accountId,omitempty"`
}

// NewSnapchatControllerActionCampaignRequest instantiates a new SnapchatControllerActionCampaignRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSnapchatControllerActionCampaignRequest() *SnapchatControllerActionCampaignRequest {
	this := SnapchatControllerActionCampaignRequest{}
	return &this
}

// NewSnapchatControllerActionCampaignRequestWithDefaults instantiates a new SnapchatControllerActionCampaignRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSnapchatControllerActionCampaignRequestWithDefaults() *SnapchatControllerActionCampaignRequest {
	this := SnapchatControllerActionCampaignRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *SnapchatControllerActionCampaignRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatControllerActionCampaignRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *SnapchatControllerActionCampaignRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *SnapchatControllerActionCampaignRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *SnapchatControllerActionCampaignRequest) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatControllerActionCampaignRequest) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *SnapchatControllerActionCampaignRequest) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *SnapchatControllerActionCampaignRequest) SetAccountId(v string) {
	o.AccountId = &v
}

func (o SnapchatControllerActionCampaignRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SnapchatControllerActionCampaignRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	return toSerialize, nil
}

type NullableSnapchatControllerActionCampaignRequest struct {
	value *SnapchatControllerActionCampaignRequest
	isSet bool
}

func (v NullableSnapchatControllerActionCampaignRequest) Get() *SnapchatControllerActionCampaignRequest {
	return v.value
}

func (v *NullableSnapchatControllerActionCampaignRequest) Set(val *SnapchatControllerActionCampaignRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSnapchatControllerActionCampaignRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSnapchatControllerActionCampaignRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSnapchatControllerActionCampaignRequest(val *SnapchatControllerActionCampaignRequest) *NullableSnapchatControllerActionCampaignRequest {
	return &NullableSnapchatControllerActionCampaignRequest{value: val, isSet: true}
}

func (v NullableSnapchatControllerActionCampaignRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSnapchatControllerActionCampaignRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
